Attribute VB_Name = "Funciones"
Option Explicit

Declare Function GetTickCount Lib "kernel32" () As Long

Const MAXSINGLE = 3.402823E+38

Type TIPO_SOLUCION
  tiempo_i As Long
  tiempo_f As Long
  nodos_recorridos() As Integer
  coste As Integer
  h_empleada As String
  sol As String         'camino en formato texto
  alg As String         'algoritmo empleado
End Type

Type TIPO_ESTADO
  nodo As Integer
  recorrido() As Integer
End Type

Public solucion As TIPO_SOLUCION
'Procedimiento que inserta un estado en una lista. Se tiene
'en cuenta al padre porque hay que "construir" el estado
'a insertar
Public Sub Insertar(ByRef lista() As TIPO_ESTADO, padre As TIPO_ESTADO, _
                    estado As TIPO_ESTADO, fin As Integer)
Dim tam As Integer
Dim i As Integer
                    
  ReDim Preserve lista(1 To fin + 1)
  tam = UBound(padre.recorrido)
  ReDim estado.recorrido(1 To tam + 1)
  For i = 1 To tam
    estado.recorrido(i) = padre.recorrido(i)
  Next i
  estado.recorrido(tam + 1) = estado.nodo
  fin = fin + 1
  lista(fin) = estado
End Sub

'Procedimiento que dado un estado actualiza las soliuciones
'en modo texto y como un camino. Si la variable bidirec es
' true entonces se tiene en cuenta el estado2 para el camino
Public Sub Camino(estado As TIPO_ESTADO, bidirec As Boolean, _
                  estado2 As TIPO_ESTADO)
Dim i As Integer
Dim tam As Integer
Dim tam2 As Integer

  tam = UBound(estado.recorrido)
  ReDim solucion.nodos_recorridos(1 To tam)
 
  solucion.coste = 0
  solucion.sol = ""
  For i = 1 To tam - 1
    solucion.nodos_recorridos(i) = estado.recorrido(i)
    solucion.coste = solucion.coste + DistanciaReal(estado.recorrido(i), _
                                     estado.recorrido(i + 1))
    solucion.sol = solucion.sol & estado.recorrido(i) & "-"
  Next i
  solucion.nodos_recorridos(i) = estado.recorrido(i)
  solucion.sol = solucion.sol & estado.recorrido(i)
   
  If (bidirec) Then
    'para el estado2
    tam2 = UBound(estado2.recorrido)
    ReDim Preserve solucion.nodos_recorridos(1 To tam + tam2 - 1)
    For i = tam2 - 1 To 2 Step -1
      solucion.nodos_recorridos(tam - i + tam2) = estado2.recorrido(i)
      solucion.coste = solucion.coste + DistanciaReal(estado2.recorrido(i), _
                                     estado2.recorrido(i - 1))
      solucion.sol = solucion.sol & "-" & estado2.recorrido(i)
    Next i
    solucion.coste = solucion.coste + DistanciaReal(estado2.recorrido(tam2), _
                                     estado2.recorrido(tam2 - 1))
    solucion.nodos_recorridos(tam + tam2 - 1) = estado2.recorrido(i)
    solucion.sol = solucion.sol & "-" & estado2.recorrido(i)
  End If
End Sub
'Procedimiento que ordena la lista pasada en oden decreciente
'segun la heuristica Hn
Public Sub Ordenar(lista() As TIPO_ESTADO, Hn As Byte)
Dim i As Integer
Dim j As Integer
Dim aux As TIPO_ESTADO

  For i = 2 To UBound(lista)
    For j = UBound(lista) To i Step -1
      If (Heuristica(Hn, lista(j - 1).nodo, nodo_f) < _
          Heuristica(Hn, lista(j).nodo, nodo_f)) Then
        aux = lista(j)
        lista(j) = lista(j - 1)
        lista(j - 1) = aux
      End If
    Next j
  Next i
End Sub
'Funcion que devuelve si un elemento est en la lista
Public Function Pertenece(nodo As Integer, lista() As TIPO_ESTADO) As Boolean
Dim i As Integer

  For i = 1 To UBound(lista)
    If (lista(i).nodo = nodo) Then
      Pertenece = True
      Exit For
    End If
  Next i
  
  Pertenece = False
End Function
'Procedimiento que elimina un elemento de la lista
Public Sub Extraer(x As Integer, lista() As TIPO_ESTADO)
Dim i As Integer
Dim j As Integer
Dim aux() As TIPO_ESTADO

  j = 1
  ReDim aux(1 To UBound(lista) - 1)
  For i = 1 To UBound(lista)
    If Not (x = lista(i).nodo) Then
      aux(j) = lista(i)
      j = j + 1
    End If
  Next i
  
  ReDim lista(1 To UBound(aux) - 1)
  For i = 1 To UBound(aux)
    lista(i) = aux(i)
  Next i
End Sub
'Procedimiento que ordena la lista pasada en oden decreciente
'segun el valor de la lista f
Public Sub Ordenar2(lista() As TIPO_ESTADO, f() As Single)
Dim i As Integer
Dim j As Integer
Dim aux As TIPO_ESTADO

  For i = 2 To UBound(lista)
    For j = UBound(lista) To i Step -1
      If (f(lista(j - 1).nodo) < f(lista(j).nodo)) Then
        aux = lista(j)
        lista(j) = lista(j - 1)
        lista(j - 1) = aux
      End If
    Next j
  Next i
End Sub

'Procedimiento que realiza la bsqueda en profundidad
Public Function Profundidad() As Boolean
Dim abierta() As TIPO_ESTADO
Dim visitados() As Boolean
Dim exito As Boolean
Dim i As Integer
Dim head As Integer         'cabecera de la lista
Dim tail As Integer         'cola de la lista
Dim estado As TIPO_ESTADO   'estado actual
Dim sucesor As TIPO_ESTADO  'sucesor actual

  solucion.tiempo_i = GetTickCount()
  
  ReDim visitados(1 To n_nodos)
  ReDim abierta(1 To 1)
  abierta(1).nodo = nodo_i
  ReDim Preserve abierta(1).recorrido(1 To 1)
  abierta(1).recorrido(1) = nodo_i
  exito = False
  head = 1
  tail = 1
  
  Do While (Not exito) And (head <= tail)
    estado = abierta(tail)
    tail = tail - 1
    visitados(estado.nodo) = True
      'sucesores de nodo
      For i = adyacentes(estado.nodo) To 1 Step -1
        If (Not visitados(lad(estado.nodo).ady(i))) Then
          sucesor.nodo = lad(estado.nodo).ady(i)
          Insertar abierta, estado, sucesor, tail
          If (lad(estado.nodo).ady(i) = nodo_f) Then
            exito = True
            Exit For
          End If
        End If        'visitado
      Next i
  Loop
  
  'Datos solucin
  solucion.tiempo_f = GetTickCount()
  solucion.alg = "Bsqueda en profundidad"
  solucion.h_empleada = "Ninguna"
  If (exito) Then
    Camino abierta(tail), False, abierta(tail)
    Profundidad = True
  Else
    solucion.coste = 0
    solucion.sol = "Camino no encontrado"
    Profundidad = False
  End If
End Function

'Funcion que hace la bsqueda en amplitud. Si no ha encontrado
'una solucin devuelve false
Public Function Amplitud() As Boolean
Dim abierta() As TIPO_ESTADO
Dim visitados() As Boolean
Dim exito As Boolean
Dim i As Integer
Dim head As Integer         'cabecera de la lista
Dim tail As Integer         'cola de la lista
Dim estado As TIPO_ESTADO   'estado actual
Dim sucesor As TIPO_ESTADO  'sucesor actual

  solucion.tiempo_i = GetTickCount()
 
  ReDim visitados(1 To n_nodos)
  ReDim abierta(1 To 1)
  abierta(1).nodo = nodo_i
  ReDim Preserve abierta(1).recorrido(1 To 1)
  abierta(1).recorrido(1) = nodo_i
  exito = False
  head = 1
  tail = 1
    
  Do While (Not exito) And (head <= tail)
    estado = abierta(head)
    head = head + 1
    visitados(estado.nodo) = True
    'sucesores de nodo
    For i = 1 To adyacentes(estado.nodo) 'sucesores
      If (Not visitados(lad(estado.nodo).ady(i))) Then
        sucesor.nodo = lad(estado.nodo).ady(i)
        Insertar abierta, estado, sucesor, tail
        If (lad(estado.nodo).ady(i) = nodo_f) Then
          exito = True
          Exit For
        End If
      End If        'visitado
    Next i
  Loop
  
  'Datos solucin
  solucion.tiempo_f = GetTickCount()
  solucion.alg = "Bsqueda en amplitud"
  solucion.h_empleada = "Ninguna"
  If (exito) Then
    Camino abierta(tail), False, abierta(tail)
    Amplitud = True
  Else
    solucion.coste = 0
    solucion.sol = "Camino no encontrado"
    Amplitud = False
  End If

End Function


'Funcion que hace la bsqueda bidireccional, en amplitud
' hacia delante y en profundidad hacia detrs. Si no ha encontrado
'una solucin devuelve false
Public Function Bidireccional() As Boolean
Dim abiertaI() As TIPO_ESTADO
Dim abiertaF() As TIPO_ESTADO
Dim visitadosI() As Boolean
Dim visitadosF() As Boolean
Dim exito As Boolean
Dim i As Integer
Dim j As Integer
Dim headI As Integer         'cabecera de la lista
Dim tailI As Integer         'cola de la lista
Dim headF As Integer         'cabecera de la lista
Dim tailF As Integer         'cola de la lista
Dim estado As TIPO_ESTADO   'estado actual
Dim sucesor As TIPO_ESTADO  'sucesor actual
Dim posI As Integer         'posicion dentro de abiertaI
                            'donde se cruzan los estados
Dim posF As Integer         'posicion dentro de abiertaF
                            'donde se cruzan los estados

  solucion.tiempo_i = GetTickCount()
  
  ReDim visitadosI(1 To n_nodos)
  ReDim visitadosF(1 To n_nodos)
  
  ReDim abiertaI(1 To 1)
  abiertaI(1).nodo = nodo_i
  ReDim Preserve abiertaI(1).recorrido(1 To 1)
  abiertaI(1).recorrido(1) = nodo_i
  
  ReDim abiertaF(1 To 1)
  abiertaF(1).nodo = nodo_f
  ReDim Preserve abiertaF(1).recorrido(1 To 1)
  abiertaF(1).recorrido(1) = nodo_f
  
  exito = False
  headI = 1
  tailI = 1
  headF = 1
  tailF = 1
    
  Do While (Not exito) And (headI <= tailI) And (headF <= tailF)
    'busqueda amplitud
    estado = abiertaI(headI)
    headI = headI + 1
    visitadosI(estado.nodo) = True
    'sucesores de nodo
    For i = 1 To adyacentes(estado.nodo)
      If (Not visitadosI(lad(estado.nodo).ady(i))) Then
        sucesor.nodo = lad(estado.nodo).ady(i)
        Insertar abiertaI, estado, sucesor, tailI
        'miramos si algun sucesor de nodo est en la otra lista
        For j = headF To tailF
          If (sucesor.nodo = abiertaF(j).nodo) Then
            exito = True
            posI = tailI
            posF = j
            Exit For
          End If
        Next j
        If exito Then Exit For
      End If    'vistados
    Next i
    
    If (Not exito) Then 'busqueda en profundidad
      estado = abiertaF(tailF)
      tailF = tailF - 1
      visitadosF(estado.nodo) = True
      For i = adyacentes(estado.nodo) To 1 Step -1
        If (Not visitadosF(lad(estado.nodo).ady(i))) Then
          sucesor.nodo = lad(estado.nodo).ady(i)
          Insertar abiertaF, estado, sucesor, tailF
          'miramos si algun sucesor de nodo est en la otra lista
          For j = headI To tailI
            If (sucesor.nodo = abiertaI(j).nodo) Then
              exito = True
              posF = tailF
              posI = j
              Exit For
            End If
          Next j
          If exito Then Exit For
        End If         'visitados
      Next i
    End If            'busqueda profundidad
  Loop
  
  'Datos solucin
  solucion.tiempo_f = GetTickCount()
  solucion.alg = "Bsqueda bidireccional"
  solucion.h_empleada = "Amplitud-Profundidad"
  If (exito) Then
    Camino abiertaI(posI), True, abiertaF(posF)
    Bidireccional = True
  Else
    solucion.coste = 0
    solucion.sol = "Camino no encontrado"
    Bidireccional = False
  End If

End Function

'Funcion que realiza la bsqueda en escalada con
'la heuristica Hn por el mtodo del gradiente (se
'escogen los k mejores sucesores)
Public Function Escalada(Hn As Byte, k As Integer) As Boolean
Dim abierta() As TIPO_ESTADO
Dim visitados() As Boolean
Dim exito As Boolean
Dim i As Integer
Dim estado As TIPO_ESTADO   'estado actual
Dim sucesor As TIPO_ESTADO  'sucesor actual
Dim head As Integer
Dim tail As Integer
Dim hijos() As TIPO_ESTADO
Dim puestos As Byte

  solucion.tiempo_i = GetTickCount()
  
  ReDim visitados(1 To n_nodos)
  ReDim abierta(1 To 1)
  abierta(1).nodo = nodo_i
  ReDim Preserve abierta(1).recorrido(1 To 1)
  abierta(1).recorrido(1) = nodo_i
  exito = False
  
  head = 1
  tail = 1

  Do While (Not exito) And (head <= tail)
    estado = abierta(tail)
    tail = tail - 1
    If Not (visitados(estado.nodo)) Then
      visitados(estado.nodo) = True
      'sucesores de nodo.
      ReDim hijos(1 To adyacentes(estado.nodo))
      For i = 1 To adyacentes(estado.nodo)
        If (lad(estado.nodo).ady(i) = nodo_f) Then
          exito = True
          sucesor.nodo = lad(estado.nodo).ady(i)
          Exit For
        End If
        hijos(i).nodo = lad(estado.nodo).ady(i)
      Next i
      If (exito) Then
        Insertar abierta, estado, sucesor, tail
      Else
       'ordenamos segn la heuristica Hn en orden decreciente
       'El ltimo es el que mejor(+ pequea) heuristica tiene
       Ordenar hijos(), Hn
       i = adyacentes(estado.nodo)
       puestos = 0
       Do While (puestos < k) And (i > 0)
       'insertamos si tiene mejor heurstica que el padre
         If (Heuristica(Hn, hijos(i).nodo, nodo_f) <= Heuristica(Hn, estado.nodo, nodo_f)) Then
           Insertar abierta, estado, hijos(i), tail
           puestos = puestos + 1
         End If
         i = i - 1
       Loop
       Ordenar abierta(), Hn
      End If    'exito - no exito
    End If       'visitado
  Loop

  'Datos solucin
  solucion.tiempo_f = GetTickCount()
  solucion.alg = "Bsqueda en escalada" & " (K=" & k & ")"
  Select Case Hn
    Case 1    'distancia eucldea
      solucion.h_empleada = Hn1
    Case 2    'distancia real
      solucion.h_empleada = Hn2
  End Select
  
  If (exito) Then
    Camino abierta(tail), False, abierta(tail)
    Escalada = True
  Else
    solucion.coste = 0
    solucion.sol = "Camino no encontrado"
    Escalada = False
  End If
End Function

'Funcion que realiza la bsqueda en escalada simple
'con la heuristica Hn. Se escoge el primer sucesor
'mejor que el padre
Public Function EscaladaSimple(Hn As Byte) As Boolean
Dim abierta() As TIPO_ESTADO
Dim visitados() As Boolean
Dim exito As Boolean
Dim i As Integer
Dim estado As TIPO_ESTADO   'estado actual
Dim sucesor As TIPO_ESTADO  'sucesor actual
Dim valor As Single                     'valor de la heuristica
Dim head As Integer
Dim tail As Integer
Dim encontrado As Boolean

  solucion.tiempo_i = GetTickCount()
  
  ReDim visitados(1 To n_nodos)
  ReDim abierta(1 To 1)
  abierta(1).nodo = nodo_i
  ReDim Preserve abierta(1).recorrido(1 To 1)
  abierta(1).recorrido(1) = nodo_i
  exito = False
  head = 1
  tail = 1

  Do While (Not exito) And (head <= tail)
    estado = abierta(tail)
    tail = tail - 1
    visitados(estado.nodo) = True
    'sucesores de nodo. Buscamos el primero mejor
    encontrado = False
    valor = Heuristica(Hn, estado.nodo, nodo_f)
    For i = adyacentes(estado.nodo) To 1 Step -1
      If (Not visitados(lad(estado.nodo).ady(i))) Then
        If (Not encontrado) And (Heuristica(Hn, lad(estado.nodo).ady(i), nodo_f) < valor) Then
          sucesor.nodo = lad(estado.nodo).ady(i)
          valor = Heuristica(Hn, lad(estado.nodo).ady(i), nodo_f)
          encontrado = True
        End If
        If (lad(estado.nodo).ady(i) = nodo_f) Then
          exito = True
          sucesor.nodo = lad(estado.nodo).ady(i)
          Exit For
        End If
      End If        'visitado
    Next i
    If (exito) Or (encontrado) Then
      Insertar abierta, estado, sucesor, tail
    End If
  Loop

  'Datos solucin
  solucion.tiempo_f = GetTickCount()
  solucion.alg = "Bsqueda en escalada simple"
  Select Case Hn
  Case 1    'distancia eucldea
    solucion.h_empleada = Hn1
  Case 2    'distancia real
    solucion.h_empleada = Hn2
End Select
  
  If (exito) Then
    Camino abierta(tail), False, abierta(tail)
    EscaladaSimple = True
  Else
    solucion.coste = 0
    solucion.sol = "Camino no encontrado"
    EscaladaSimple = False
  End If
End Function

'Funcin que realiza el algoritmo de recristalizacin
'simulada con la heurstica Hn. El programa de enfriamiento
'se representa con T para el valor incial y con dec como valor
'a decrementar.
Public Function Recristalizacion(T As Single, dec As Single, Hn As Byte) As Boolean
Dim actual As TIPO_ESTADO
Dim abierta() As TIPO_ESTADO
Dim sucesor As TIPO_ESTADO  'sucesores de actual
Dim visitados() As Boolean
Dim exito As Boolean
Dim insertado As Boolean
Dim p As Single
Dim p_  As Single
Dim valor_actual As Single
Dim valor_sucesor As Single
Dim i As Integer
Dim tail As Integer
Dim candidato As Integer

  solucion.tiempo_i = GetTickCount()
  
  ReDim visitados(1 To n_nodos)
  ReDim abierta(1 To 1)
  abierta(1).nodo = nodo_i
  ReDim Preserve abierta(1).recorrido(1 To 1)
  abierta(1).recorrido(1) = nodo_i
  
  tail = 1
  visitados(nodo_i) = True
  exito = False
  Randomize     'inicializamos num aleatorios
  
  Do While (T > 0.1) And (Not exito) And (tail > 0)
    actual = abierta(tail)
    tail = tail - 1
    valor_actual = Heuristica(Hn, actual.nodo, nodo_f)
    insertado = False
    candidato = 0
    For i = 1 To adyacentes(actual.nodo)
      sucesor.nodo = lad(actual.nodo).ady(i)
      If (Not visitados(sucesor.nodo)) Then
        If (sucesor.nodo = nodo_f) Then
          tail = 0
          Insertar abierta, actual, sucesor, tail
          exito = True
          visitados(sucesor.nodo) = True
          Exit For
        
        Else
          valor_sucesor = Heuristica(Hn, sucesor.nodo, nodo_f)
          If (valor_sucesor < valor_actual) Then
            tail = 0
            Insertar abierta, actual, sucesor, tail
            insertado = True
            valor_actual = valor_sucesor
            'Exit For
          ElseIf (Not insertado) Then    'caculamos la probabilidad p
            p = Exp((valor_actual - valor_sucesor) / T)
            If (p > Rnd()) Then
              candidato = i
              'Exit For
            End If
          End If
        End If      'nodo_f
        
      End If        'visitado
    Next i
    
    'If (abierta(1).nodo = actual.nodo) Then Exit Do
    If (Not exito) And (Not insertado) And (candidato <> 0) Then
      sucesor.nodo = lad(actual.nodo).ady(candidato)
      tail = 0
      Insertar abierta, actual, sucesor, tail
    End If
    If tail > 0 Then visitados(abierta(tail).nodo) = True
    T = T - dec
  Loop

  'Datos solucin
  solucion.tiempo_f = GetTickCount()
  solucion.alg = "Recristalizacin simulada"
  Select Case Hn
  Case 1    'distancia eucldea
    solucion.h_empleada = Hn1
  Case 2    'distancia real
    solucion.h_empleada = Hn2
  End Select
  
  If (exito) Then
    Camino abierta(tail), False, abierta(tail)
    Recristalizacion = True
  Else
    solucion.coste = 0
    solucion.sol = "Camino no encontrado"
    Recristalizacion = False
  End If

End Function

Function A_estrella(Hn As Byte) As Boolean
Dim actual As TIPO_ESTADO
Dim abierta() As TIPO_ESTADO
Dim tail As Integer
Dim exito As Boolean
Dim i As Byte
Dim g() As Single      'coste hasta el nodo
Dim f() As Single      'coste hasta el nodo + heuristica
Dim sucesor As TIPO_ESTADO
Dim hijos() As TIPO_ESTADO
Dim visitados() As Boolean

  solucion.tiempo_i = GetTickCount()

  ReDim g(1 To n_nodos)
  ReDim f(1 To n_nodos)
  ReDim visitados(1 To n_nodos)
  
  For i = 1 To n_nodos
    g(i) = 0
  Next i
  
  ReDim abierta(1 To 1)
  abierta(1).nodo = nodo_i
  ReDim Preserve abierta(1).recorrido(1 To 1)
  abierta(1).recorrido(1) = nodo_i
  
  tail = 1
  exito = False
  
  
  Do While (tail > 0) And (Not exito)
    actual = abierta(tail)
    tail = tail - 1
    If (Not visitados(actual.nodo)) Then
      visitados(actual.nodo) = True
      'lista de hijos
      ReDim hijos(1 To adyacentes(actual.nodo))
      For i = 1 To adyacentes(actual.nodo)
        If (lad(actual.nodo).ady(i) = nodo_f) Then
          exito = True
          sucesor.nodo = lad(actual.nodo).ady(i)
          Exit For
        End If
        hijos(i).nodo = lad(actual.nodo).ady(i)
      Next i
      'si el nodo final estaba entre los hijos salimos del while
      If (exito) Then
        Insertar abierta, actual, sucesor, tail
        Exit Do
      End If
    
      For i = 1 To adyacentes(actual.nodo)
        sucesor.nodo = hijos(i).nodo
        If (Pertenece(sucesor.nodo, abierta)) Then
          If (g(sucesor.nodo) > (g(actual.nodo) + DistanciaReal(actual.nodo, sucesor.nodo))) Then
            g(sucesor.nodo) = g(actual.nodo) + DistanciaReal(actual.nodo, sucesor.nodo)
            f(sucesor.nodo) = g(sucesor.nodo) + Heuristica(Hn, sucesor.nodo, nodo_f)
           ' Extraer hijos(i).nodo, abierta()
          'Else
           ' Extraer hijos(i).nodo, hijos()
          End If
        Else   'no pertenece
          g(sucesor.nodo) = g(actual.nodo) + DistanciaReal(actual.nodo, sucesor.nodo)
          f(sucesor.nodo) = g(sucesor.nodo) + Heuristica(Hn, sucesor.nodo, nodo_f)
          Insertar abierta, actual, hijos(i), tail
        End If    'pertenece
      Next i
      'Insertar y ordenar (fusion)
      
      'For i = 1 To UBound(hijos)
        'Insertar abierta, actual, hijos(i), tail
      'Next i
      Ordenar2 abierta(), f()
    End If      'visitado
  Loop
  
  
  'Datos solucin
  solucion.tiempo_f = GetTickCount()
  solucion.alg = "Algoritmo A*"
  Select Case Hn
  Case 1    'distancia eucldea
    solucion.h_empleada = Hn1
  Case 2    'distancia real
    solucion.h_empleada = Hn2
  End Select
  
  If (exito) Then
    Camino abierta(tail), False, abierta(tail)
    A_estrella = True
  Else
    solucion.coste = 0
    solucion.sol = "Camino no encontrado"
    A_estrella = False
  End If
End Function
