Attribute VB_Name = "Heuristicas"
Option Explicit

Public Const Hn1 = "Distancia eucldea"
Public Const Hn2 = "Distancia real"

'Funcin que llama a las diferentes heurstacas segn el
'valor de Hn
Public Function Heuristica(Hn As Byte, n_origen As Integer, _
                            n_destino As Integer) As Single
                            
Select Case Hn
  Case 1    'distancia eucldea
    Heuristica = DistanciaEuclidea(n_origen, n_destino)
  Case 2    'distancia real
    Heuristica = DistanciaReal(n_origen, n_destino)
  Case 3
End Select
                            
End Function



'Funcin que devuelve la distancia real en la direccin X
'entre dos nodos
Public Function DistanciaRealX(n_origen As Integer, _
                            n_destino As Integer) As Integer
                            
  DistanciaRealX = Abs(lad(n_origen).pos.x - _
                       lad(n_destino).pos.x)

End Function

'Funcin que devuelve la distancia real en la direccin Y
'entre dos nodos
Public Function DistanciaRealY(n_origen As Integer, _
                            n_destino As Integer) As Integer

  DistanciaRealY = Abs(lad(n_origen).pos.y - _
                       lad(n_destino).pos.y)
End Function
'Funcin que devuelve la distancia real entre dos nodos
Public Function DistanciaReal(n_origen As Integer, _
                            n_destino As Integer) As Integer

  DistanciaReal = DistanciaRealX(n_origen, n_destino) + _
                  DistanciaRealY(n_origen, n_destino)
End Function


'Funcion que devuelve la distancia eucldea entre los dos
'nodos pasados como parmetros
Public Function DistanciaEuclidea(n_origen As Integer, _
                                n_destino As Integer) As Single
Dim aux1 As Integer
Dim aux2 As Integer

  aux1 = (lad(n_destino).pos.x - lad(n_origen).pos.x) ^ 2
  aux2 = (lad(n_destino).pos.y - lad(n_origen).pos.y) ^ 2
  DistanciaEuclidea = Sqr(aux1 + aux2)
End Function

