Attribute VB_Name = "Principal"
Option Explicit
'constantes
Public Const MAXINT = 32.767
Public Const MININT = -32.768
'TIPOS
Type TIPO_PUNTO     'posicin de un nodo
  X As Integer
  Y As Integer
End Type

Type TIPO_NODO          'datos de un nodo
  n_nodo As Integer     'n de nodo
  pos As TIPO_PUNTO     'posicin del nodo
  ady() As Integer      'lista de nodos adyacentes
End Type
 
Public n_nodos As Integer   'n de nodos totales
Public nodo_i As Integer    'nodo inicial
Public nodo_f As Integer    'nodo final
Public lad() As TIPO_NODO   'Lista de adyacencia
Public adyacentes() As Integer  'n de nodos adyacentes al del indice
Public matrizA() As Boolean 'matriz de adyacencia

'control
Public puntos As Boolean    'indica si se han cargado los puntos
Public adyacencia As Boolean 'indica si se ha cargado la matriz de adyacencia
'parmetros de la ventana grfica
Public MinX As Integer
Public MaxX As Integer
Public MinY As Integer
Public MaxY As Integer
Public pasoX As Single
Public pasoY As Single

Const MARGEN = 50
Const radio = 10

Sub Main()

  ChDir App.Path
  MDIFrmMain.Show
  
  puntos = False
  adyacencia = False
End Sub
'Procedimiento que lee un archivo de puntos
Public Sub LeerP(file As String)
Dim fd As Integer
Dim i As Integer

  fd = FreeFile
  Open file For Input As fd
  
  'n total de nodos, nodo inicial y nodo final
  Input #fd, n_nodos, nodo_i, nodo_f
  
  
  ReDim lad(1 To n_nodos)
  For i = 1 To n_nodos
    lad(i).n_nodo = i
    Input #fd, lad(i).pos.X, lad(i).pos.Y
  Next i
    
  puntos = True
  Close fd
End Sub

'Procedimiento que lee un archivo con la matriz de adyacencia
Public Sub LeerA(file As String)
Dim fd As Integer
Dim i As Integer
Dim j As Integer
Dim aux As Integer

  If Not puntos Then
    MsgBox "No se han introducido las coordenadas de los nodos", vbInformation
    Exit Sub
  End If

  fd = FreeFile
  Open file For Input As fd
 
  ReDim matrizA(1 To n_nodos, 1 To n_nodos)
  For i = 1 To n_nodos
    For j = 1 To n_nodos
      Input #fd, aux
      If aux = 1 Then
        matrizA(i, j) = True
      Else
        matrizA(i, j) = False
      End If
    Next j
  Next i

  adyacencia = True
  Close fd
End Sub
'Procedimiento que construye la Lista de Adyacencia
Public Sub ConstruirLAD()
Dim i As Integer
Dim j As Integer

  ReDim adyacentes(1 To n_nodos)
  For i = 1 To n_nodos
    adyacentes(i) = 0
    For j = 1 To n_nodos
      If (matrizA(i, j)) Then
        adyacentes(i) = adyacentes(i) + 1
        ReDim Preserve lad(i).ady(1 To adyacentes(i))
        lad(i).ady(UBound(lad(i).ady)) = j
      End If
    Next j
  Next i
End Sub
'Procedimiento que calcula los parmetros de la ventana
'grafica
' a = MinX
' b = MinY
' c = MaxX
' d = MaxY
Public Sub CalcularParametros(a As Integer, b As Integer, _
                         c As Integer, d As Integer)
Dim i As Integer
  
  'si hemos leido desde fichero encontramos los extremos
  If (a = 0) And (b = 0) And (c = 0) And (d = 0) Then
    MinX = MAXINT
    MinY = MAXINT
    MaxX = MININT
    MaxY = MININT
    For i = 1 To n_nodos
      If (lad(i).pos.X < MinX) Then MinX = lad(i).pos.X
      If (lad(i).pos.X > MaxX) Then MaxX = lad(i).pos.X
      If (lad(i).pos.Y < MinY) Then MinY = lad(i).pos.Y
      If (lad(i).pos.Y > MaxY) Then MaxY = lad(i).pos.Y
    Next i
  Else 'creados aleatorios
    MinX = a
    MinY = b
    MaxX = c
    MaxY = d
  End If
  
  FrmGrafico.Show
  'calculamos la escala
  pasoX = (FrmGrafico.Pic.ScaleWidth - MARGEN) / (MaxX - MinX)
  pasoY = (FrmGrafico.Pic.ScaleHeight - MARGEN) / (MaxY - MinY)

End Sub
'Funcin que devuelve la posicin X dentro de la ventana
'grfica que le corresponde a la posicin X pasada
Public Function PosicionX(pos As Integer)

  PosicionX = (pos - MinX) * pasoX + MARGEN / 2
End Function

'Funcin que devuelve la posicin Y dentro de la ventana
'grfica que le corresponde a la posicin Y pasada
Public Function PosicionY(pos As Integer)

  PosicionY = (pos - MinY) * pasoY + MARGEN / 2
End Function
'Procedimiento que pone el n del nodo dentro del nodo
Public Sub PonNumeros()
Dim i As Integer
Dim escribir As String
Dim posx As Integer
Dim posy As Integer
Dim coordenadas As String

  For i = 1 To n_nodos
    coordenadas = "(" & lad(i).pos.X & "," & lad(i).pos.Y & ")"
    'If (i = nodo_i) Then
      'escribir = "In"
    'ElseIf (i = nodo_f) Then
      'escribir = "F"
    'Else
      escribir = i
    'End If
    posx = PosicionX(lad(i).pos.X)
    posy = PosicionY(lad(i).pos.Y)
    'ponemos el nmero
    FrmGrafico.Pic.CurrentX = posx - radio / 2
    FrmGrafico.Pic.CurrentY = posy - radio / 2
    FrmGrafico.Pic.Print escribir
    'ponemos las coordenandas
    FrmGrafico.Pic.CurrentX = posx - radio - 2
    FrmGrafico.Pic.CurrentY = posy + radio
    FrmGrafico.Pic.Print coordenadas
  Next i
End Sub

'Procedimiento que pone los nodos en el formulario grfico
'necesitamos saber las coordenadas mximas y mnimas en
'ambas direcciones
Public Sub DibujarPuntos()
Dim i As Integer
Dim color As Long   'color de relleno
Dim posx As Integer
Dim posy As Integer

  'estilo y relleno de los puntos
  FrmGrafico.Pic.FillStyle = vbFSSolid
  color = RGB(255, 125, 0)
  For i = 1 To n_nodos
    If (i = nodo_i) Then
      FrmGrafico.Pic.FillColor = vbCyan
    ElseIf (i = nodo_f) Then
      FrmGrafico.Pic.FillColor = vbYellow
    Else
      FrmGrafico.Pic.FillColor = color
    End If
    posx = PosicionX(lad(i).pos.X)
    posy = PosicionY(lad(i).pos.Y)
    PonPunto posx, posy
  Next i
  
  PonNumeros
  FrmGrafico.Pic.FillStyle = vbFSTransparent
End Sub

'Procedimiento que pone un punto en la posicin indicada
'con posX y posY en el formulario grfico
Public Sub PonPunto(posx As Integer, posy As Integer)
Const color = vbBlack   'color del crculo, no del relleno
  
  FrmGrafico.Pic.Circle (posx, posy), radio, color
End Sub
'Procedimiento que dibuja una lnea en la ventana grfica
'a partir de dos puntos reales
Public Sub PonLinea(x1 As Integer, y1 As Integer, _
                    x2 As Integer, y2 As Integer, color As Long)
Dim a, b, c, d As Integer

  a = PosicionX(x1)
  b = PosicionY(y1)
  c = PosicionX(x2)
  d = PosicionY(y2)
  FrmGrafico.Pic.Line (a, b)-(c, d), color
                   
End Sub
'Procedimiento que dibuja las relaciones de adyancencia
'entre los nodos a partir de la LAD
Public Sub DibujarAdyacencia()
Dim i As Integer
Dim j As Integer
Dim adyacente As TIPO_NODO    'nodo adyacente

  For i = 1 To n_nodos
    For j = 1 To UBound(lad(i).ady)
      adyacente = lad(lad(i).ady(j))
      'ponemos las lneas
      PonLinea lad(i).pos.X, lad(i).pos.Y, adyacente.pos.X, adyacente.pos.Y, vbRed
    Next j
  Next i
  DibujarPuntos
End Sub


'Procedimiento que presenta la solucin en modo grfico
Public Sub PresentacionGrafica()
Dim i As Integer
Dim n As Integer    'nodo actual
Dim sig As Integer

  FrmGrafico.Pic.DrawWidth = 2
  For i = 1 To UBound(solucion.nodos_recorridos) - 1
    n = solucion.nodos_recorridos(i)
    sig = solucion.nodos_recorridos(i + 1)
    PonLinea lad(n).pos.X, lad(n).pos.Y, lad(sig).pos.X, lad(sig).pos.Y, vbGreen
  Next i
  PonNumeros
  FrmGrafico.Pic.DrawWidth = 1
  DibujarPuntos
End Sub
'Procedimiento que presenta la solucin en modo texto. Los
'parametros indican:
'fila: fila a usar dentro del grid
'filas: n total de filas en el grid
Public Sub PresentacionTexto(fila As Byte, filas As Byte)
Dim columnas As Byte
  
  FrmResultados.Show
  FrmResultados.Grid.Rows = filas + 1
  FrmResultados.Grid.Cols = 5
  'encabezado columnas y tamao
  FrmResultados.Grid.ColWidth(0) = 2250
  FrmResultados.Grid.TextMatrix(0, 0) = "Algoritmo"
  FrmResultados.Grid.ColWidth(1) = 3200
  FrmResultados.Grid.TextMatrix(0, 1) = "Camino"
  FrmResultados.Grid.ColWidth(2) = 600
  FrmResultados.Grid.TextMatrix(0, 2) = "Coste"
  FrmResultados.Grid.ColWidth(3) = 900
  FrmResultados.Grid.TextMatrix(0, 3) = "Tiempo"
  FrmResultados.Grid.ColWidth(4) = 1600
  FrmResultados.Grid.TextMatrix(0, 4) = "Heurstica"
  
  'datos
  FrmResultados.Grid.TextMatrix(fila, 0) = solucion.alg
  FrmResultados.Grid.TextMatrix(fila, 1) = solucion.sol
  FrmResultados.Grid.TextMatrix(fila, 2) = solucion.coste
  FrmResultados.Grid.TextMatrix(fila, 3) = _
  Format((solucion.tiempo_f - solucion.tiempo_i) / 1#, "###0.00") + _
      " ms"
  FrmResultados.Grid.TextMatrix(fila, 4) = solucion.h_empleada
End Sub
